"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
/**
 * Script will create json data, which contains dictionaries for runtime,
 * where `key` is name of folder we want icon for and `value` is icon's filename.
 */
var log4js = require("log4js");
var fs_1 = require("fs");
var path_1 = require("path");
var log = log4js.getLogger(path_1.basename(__filename, path_1.extname(__filename)));
log.level = "debug";
// Open icon definitions
log.debug("opening icon definitions");
var iconsJSONFile = fs_1.readFileSync('./data/generated/icons.json');
var vsiLanguagesFile = fs_1.readFileSync('./data/generated/languages-vsi.json');
var vscodeLanguagesFile = fs_1.readFileSync('./data/static/languages-vscode.json');
var PATH_ICONSDATA = './src/generated/';
// Parse icon definitions
log.debug("parsing icon definitions");
var icons = JSON.parse(iconsJSONFile.toString());
var vsiLanguages = JSON.parse(vsiLanguagesFile.toString());
var vscodeLanguages = JSON.parse(vscodeLanguagesFile.toString());
// Icon To Path
var iconToPath = Object.keys(icons.iconDefinitions).reduce(function (acc, icon) {
    var _a;
    return (__assign({}, acc, (_a = {}, _a[icon] = icons.iconDefinitions[icon].iconPath.split('/').pop(), _a)));
}, {});
function getIconPath(icon) {
    return iconToPath[icon];
}
// FolderNames to Icon
(function () {
    return __awaiter(this, void 0, void 0, function () {
        var folderIcons, _i, _a, _b, folderName, icon;
        return __generator(this, function (_c) {
            log.debug("creating table for foldernames");
            folderIcons = fs_1.createWriteStream(PATH_ICONSDATA + 'FolderNamesToIcon.ts', { flags: 'w' });
            folderIcons.write("export const FolderNamesToIcon: { [key: string]: string } = {\n");
            for (_i = 0, _a = Object.entries(icons.light.folderNames); _i < _a.length; _i++) {
                _b = _a[_i], folderName = _b[0], icon = _b[1];
                folderIcons.write("\t'" + folderName + "': '" + getIconPath(icon) + "',\n");
            }
            folderIcons.write("};\n");
            folderIcons.end();
            return [2 /*return*/];
        });
    });
})();
// FileExtensions to Icon
(function () {
    return __awaiter(this, void 0, void 0, function () {
        var fileExtensions1, fileExtensions2, _i, _a, _b, extension, icon;
        return __generator(this, function (_c) {
            log.debug("creating table for filextensions");
            fileExtensions1 = fs_1.createWriteStream(PATH_ICONSDATA + 'FileExtensions1ToIcon.ts', { flags: 'w' });
            fileExtensions2 = fs_1.createWriteStream(PATH_ICONSDATA + 'FileExtensions2ToIcon.ts', { flags: 'w' });
            fileExtensions1.write("export const FileExtensions1ToIcon: { [key: string]: string } = {\n");
            fileExtensions2.write("export const FileExtensions2ToIcon: { [key: string]: string } = {\n");
            for (_i = 0, _a = Object.entries(icons.light.fileExtensions); _i < _a.length; _i++) {
                _b = _a[_i], extension = _b[0], icon = _b[1];
                if (extension.indexOf(".") === -1) {
                    fileExtensions1.write("\t'" + extension + "': '" + getIconPath(icon) + "',\n");
                }
                else {
                    fileExtensions2.write("\t'" + extension + "': '" + getIconPath(icon) + "',\n");
                }
            }
            fileExtensions1.write("};\n");
            fileExtensions2.write("};\n");
            fileExtensions1.end();
            fileExtensions2.end();
            return [2 /*return*/];
        });
    });
})();
// FileNames to Icon
(function () {
    return __awaiter(this, void 0, void 0, function () {
        var alreadyIncludedNames, filenames, _i, _a, _b, filename, icon, _c, _d, _e, language, data, _f, _g, filename;
        return __generator(this, function (_h) {
            log.debug("creating table for filenames");
            alreadyIncludedNames = [];
            filenames = fs_1.createWriteStream(PATH_ICONSDATA + 'FileNamesToIcon.ts', { flags: 'w' });
            filenames.write("export const FileNamesToIcon: { [key: string]: string } = {\n");
            // get folder names from vsi langauges definitions
            for (_i = 0, _a = Object.entries(icons.light.fileNames); _i < _a.length; _i++) {
                _b = _a[_i], filename = _b[0], icon = _b[1];
                filenames.write("\t'" + filename + "': '" + getIconPath(icon) + "',\n");
                alreadyIncludedNames.push(filename);
            }
            // get folder names from vscode languages definitions
            for (_c = 0, _d = Object.entries(vscodeLanguages); _c < _d.length; _c++) {
                _e = _d[_c], language = _e[0], data = _e[1];
                if (data.filenames && Object.keys(vsiLanguages).includes(language) && getIconPath("_f_" + language)) {
                    for (_f = 0, _g = data.filenames; _f < _g.length; _f++) {
                        filename = _g[_f];
                        if (!alreadyIncludedNames.includes(filename)) {
                            filenames.write("\t'" + filename + "': '" + getIconPath("_f_" + language) + "',\n");
                            alreadyIncludedNames.push(filename);
                        }
                    }
                }
            }
            filenames.write("};\n");
            filenames.end();
            return [2 /*return*/];
        });
    });
})();
// Languages to Icon
(function () {
    return __awaiter(this, void 0, void 0, function () {
        var alreadyIncludedLangs, languages, _i, _a, _b, language, icon, iconFileName, withoutPrefix, lightIconFilename, existsLightTheme, iconPath, supportedExtensions, languageExtensions, _c, supportedExtensions_1, extension, _d, _e, _f, extIcon, extIconPath;
        return __generator(this, function (_g) {
            log.debug("creating table for languages");
            alreadyIncludedLangs = [];
            languages = fs_1.createWriteStream(PATH_ICONSDATA + 'LanguagesToIcon.ts', { flags: 'w' });
            languages.write("export const LanguagesToIcon: { [key: string]: string } = {\n");
            for (_i = 0, _a = Object.entries(vsiLanguages); _i < _a.length; _i++) {
                _b = _a[_i], language = _b[0], icon = _b[1];
                iconFileName = icons.languageIds[language];
                if (iconFileName) {
                    withoutPrefix = iconFileName.slice(3);
                    lightIconFilename = "_f_light_" + withoutPrefix;
                    existsLightTheme = icons.iconDefinitions[lightIconFilename];
                    iconPath = existsLightTheme
                        ? getIconPath(lightIconFilename)
                        : getIconPath(iconFileName);
                    // Are there any language extensions supported by vscode ?
                    if (vscodeLanguages[language]) {
                        supportedExtensions = vscodeLanguages[language].extensions;
                        languageExtensions = {};
                        for (_c = 0, supportedExtensions_1 = supportedExtensions; _c < supportedExtensions_1.length; _c++) {
                            extension = supportedExtensions_1[_c];
                            languageExtensions[extension.slice(1)] = iconPath; // .cpp => cpp
                        }
                        ;
                        // Override default extension
                        // languageExtensions[icon.defaultExtension] = iconPath;
                        for (_d = 0, _e = Object.entries(languageExtensions); _d < _e.length; _d++) {
                            _f = _e[_d], extIcon = _f[0], extIconPath = _f[1];
                            if (!alreadyIncludedLangs.includes(extIcon)) {
                                languages.write("\t'" + extIcon + "': '" + extIconPath + "',\n");
                                alreadyIncludedLangs.push(extIcon);
                            }
                        }
                    }
                    else {
                        if (!alreadyIncludedLangs.includes(icon.defaultExtension)) {
                            languages.write("\t'" + icon.defaultExtension + "': '" + iconPath + "',\n");
                            alreadyIncludedLangs.push(icon.defaultExtension);
                        }
                    }
                }
                // languages.write(`\t"${filename}": "${getIconPath(icon)}",\n`);
            }
            languages.write("};\n");
            languages.end();
            return [2 /*return*/];
        });
    });
})();
