"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
/**
 * This script will extract data from vscode-icons, those data will be later used to
 * Create Icons Data, which will be used in runtime as dictionary where `key` is name of folder
 * we want icon for and `value` is icon's filename.
 */
var log4js = require("log4js");
var node_fetch_1 = require("node-fetch");
var fs_1 = require("fs");
var path_1 = require("path");
var log = log4js.getLogger(path_1.basename(__filename, path_1.extname(__filename)));
log.level = "debug";
var LANG_URL = 'https://raw.githubusercontent.com/vscode-icons/vscode-icons/master/src/iconsManifest/languages.ts';
var reKey = /(.*?):/;
var reIds = /ids:.*'(.*?)'/;
node_fetch_1.default(LANG_URL, {})
    .then(function (res) { return res.text(); })
    .then(function (body) {
    var bodyLines = body.split('\n').slice(3, -2);
    var languages = {};
    var keyIdExt = bodyLines.map(function (fLine) {
        var line = fLine.trim();
        var key = reKey.exec(line);
        // const ids = reIds.exec(line);
        var ext = reIds.exec(line);
        if (key && ext) {
            languages[key[1]] = {
                defaultExtension: ext[1]
            };
        }
    });
    var languagesJSON = JSON.stringify(languages, null, 2);
    fs_1.writeFileSync('./data/generated/languages-vsi.json', languagesJSON);
    log.info("sucesffullly downloaded and generated langauge definitions");
});
